@ECHO OFF
REM //========================================================================
REM // Copyright (c) Technische Software Entwicklung Plazotta © 2021
REM //
REM // DESCRIPTION:
REM //    Batch Building for INtime / Project Framework.Core
REM //
REM // HISTORY:
REM //    27.07.2021 / DM
REM //       Module created.
REM //========================================================================
setlocal
pushd .
REM =======================================================================
REM Setup Parameter
REM =======================================================================
set ProjectName=@TSEP_AUTOBUILD_PROJECT@
set UnitTestExecutables=@TSEP_AUTOBUILD_USED_UNITTEST@
REM
REM =======================================================================
REM Rebuild the project
REM =======================================================================
cd scripts
call BuildVS2017INtimeProject.cmd %ProjectName% Release "%UnitTestExecutables%"
IF %ERRORLEVEL% NEQ 0 goto ERROR
call BuildVS2017INtimeProject.cmd %ProjectName% Debug "%UnitTestExecutables%"
IF %ERRORLEVEL% NEQ 0 goto ERROR
goto END
REM
REM =======================================================================
REM Error
REM =======================================================================
:ERROR
echo Error during automated build ......
PAUSE
exit /b 1
REM
REM =======================================================================
REM END
REM =======================================================================
:END
echo Automated build successful done .....
exit /b 0
