###########################################################################################
#
# (c) Technical Software Engineering Plazotta 2021
#
# CMAKE project file / @Add your project name@
#
#
#-----------------------------------------------------------------------------------------
# Define project specific requirements
#
# Project name, output file name, project description
#
set(PROJECT_NAME         @Add your project name@)
set(PROJECT_OUTPUT_NAME  @Add your project dll name@)
set(PROJECT_DESCRIPTION  "@Add your project description@")
#
#-----------------------------------------------------------------------------------------
#
# qt moc, rcc uic
#
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
#
# Define group file names
#
# SOURCE FILES
#
set(SOURCE_FILES
  src/...
)
#
# HEADER FILES
#
set(HEADER_FILES
  src/...
)
#
# UI FILES
#
set(UI_FILES
  ui/...
)
qt5_wrap_ui(UI_FILES_WRAPPED ${UI_FILES})
#
#
# TRANSLATION
#
# Define supported Language
set(LANGUAGES
  de
)
#
# Create .ts and .qm Files
TSEP_TRANSLATE(${LANGUAGES})
#
#
# RESOURCE FILES
#
set(RESOURCE_FILES
  resources/...
)
#
# Define folders for group files
#
source_group("Source Files" FILES ${SOURCE_FILES})
source_group("Header Files" FILES ${HEADER_FILES})
source_group("UI Files" FILES ${UI_FILES} ${UI_FILES_WRAPPED})
source_group("Resource Files" FILES ${RESOURCE_FILES})
#
# Include files, add your own includes
#
include_directories(
  ${CMAKE_CURRENT_LIST_DIR}/src
#  /- Add your additional include paths -/
)
#
#-----------------------------------------------------------------------------------------
# Gui application definitions
#
# Setup application version
#
TSEP_SETUP_APP_VERSION(${PROJECT_DESCRIPTION})
#
# Create gui application
#
add_executable(${PROJECT_NAME} WIN32
  ${SOURCE_FILES}
  ${HEADER_FILES}
  ${UI_FILES}
  ${UI_FILES_WRAPPED}
  ${RESOURCE_FILES}
  ${TSEP_APP_VERSION_RC}
  ${TSEP_TRANSLATION_FILES}
)
#
# Setup TSEP OS specific settings for the project
#
TSEP_ADD_OS_SPECIFIC_SETTINGS()
#
# Setup output
#
set_target_properties(${PROJECT_NAME} PROPERTIES OUTPUT_NAME ${PROJECT_OUTPUT_NAME})
#
# Add used libs
#
#target_link_libraries(${PROJECT_NAME}
#  PUBLIC
#  /- Add your additional libraries -/
#)
#
#
# Include application data files
# i.e 
#set (APPLICATION_DATA_FILES
#    "certificates" ${CMAKE_CURRENT_LIST_DIR}/../Test/certificates/Themis.cer
#)
#
#set (APPLICATION_DATA_FILES
#    "Folder in application data folder, may be empty" ${CMAKE_CURRENT_LIST_DIR}/../folder/File_to_Be_Used
#)

# Create links to necessary dependency libraries
#
TSEP_GENERATE_DEPENDENCY_LINKS()
#
# Create an Export directory with the defined data
#
TSEP_CREATE_EXPORT()
#
