###########################################################################################
# 
# (c) Technical Software Engineering Plazotta 2021
#
# CMAKE template file to upload the paket into Nexus
#
#
#-----------------------------------------------------------------------------------------
# Define project specific requirements
#
set(PROJECT_NAME          NEXUS_UPLOAD)
set(PROJECT_DESCRIPTION  "TSEP Nexus upload project")

add_custom_target(${PROJECT_NAME}
                   COMMENT "Upload Nexus Paket ..."
                   VERBATIM
                   WORKING_DIRECTORY ${TSEP_EXPORT_DIR}
                   COMMAND_EXPAND_LISTS
                   COMMAND ${TSEP_NUGET_APPLICATION} pack ${TSEP_EXPORT_DIR}/${TSEP_PRODUCT_NAME}.nuspec -outputdirectory ${TSEP_EXPORT_DIR} -BasePath ${TSEP_EXPORT_DIR} -verbosity detailed
                   COMMAND ${TSEP_NUGET_APPLICATION} push *.nupkg ${TSEP_NEXUS_GUID} -source ${TSEP_NEXUS_URL}/Development/ -verbosity detailed
)

set_target_properties(${PROJECT_NAME} PROPERTIES FOLDER "CMakePredefinedTargets")
set_target_properties(${PROJECT_NAME} PROPERTIES EXCLUDE_FROM_ALL 1 EXCLUDE_FROM_DEFAULT_BUILD 1)

